<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
<Title> Tango Device Server User's Guide </Title>
</HEAD>
<BODY TEXT="#000000" BGCOLOR="#FFFFFF" LINK="#0000FF" VLINK="#7F00FF" ALINK="#FF0000">

<P><!-------TITLE------></P>

<TABLE BORDER="0" WIDTH="100%">
    <TR>
        <TD ALIGN="left">
			<A HREF="http://www.esrf.fr/" TARGET=new>
			<IMG SRC="http://www.esrf.fr/gifs/logo/80.gif" BORDER=0></A>
		</Td>
        <TD ALIGN="center">
			<A HREF="http://www.elettra.trieste.it/" TARGET=new>
			<IMG SRC="http://www.esrf.fr/computing/cs/tango/elettra_logo.gif" BORDER=0></A>

		</Td>
        <TD ALIGN="right">
			<A HREF="http://www.synchrotron-soleil.fr/" TARGET=new>
			<IMG SRC="http://www.esrf.fr/computing/cs/tango/soleil_logo.gif" BORDER=0></A>
		</Td>
    	 <Td>
    	 <Td>
			<H2><FONT COLOR="#7F00FF">
			<Center><A HREF="http://www.esrf.fr/Infrastructure/Computing/tango/" TARGET="_top">
					 TANGO </a> <Br> Device Server
			</Center></FONT>
    	</Td>
    </TR>
</TABLE>

<HR WIDTH="100%"></H5>
<Br>
<center>
<h1>
Starter for Tango Administration		<Br>
Device Commands Description 		<Br> <Br>
Starter Class	<Br>
</h1>
<b>
Revision: Release_2_3 - Author: pascal_verdier -  CVS repository: sourceforge(tango-cs)
</b>
</center>


<Br>
<Br>
<Br>
<A NAME="Init"><!-- --></A>
<A NAME="Init"><!-- --></A>
<h2>1 - Init</h2>
<ul>
<Li><Strong>Description: </Strong> This commands re-initialise a device keeping the same network connection.<Br>
After an Init command executed on a device, it is not necessary for client to re-connect to the device.<Br>
This command first calls the device <i> delete_device() </i>method and then execute its <i> init_device()</i> method.<Br>
For C++ device server, all the memory allocated in the <i> nit_device() </i> method must be freed in the <i> delete_device() </i> method.<Br>
The language device desctructor automatically calls the <i> delete_device() </i> method.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_VOID</Strong>
 : none.<Br>&nbsp
<Li><Strong>Argout:<Br>DEV_VOID</Strong>
 : none.<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="State"><!-- --></A>
<A NAME="State"><!-- --></A>
<h2>2 - State</h2>
<ul>
<Li><Strong>Description: </Strong> This command gets the device state (stored in its <i>device_state</i> data member) and returns it to the caller.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_VOID</Strong>
 : none.<Br>&nbsp
<Li><Strong>Argout:<Br>DEV_STATE</Strong>
 : State Code<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="Status"><!-- --></A>
<A NAME="Status"><!-- --></A>
<h2>3 - Status</h2>
<ul>
<Li><Strong>Description: </Strong> This command gets the device status (stored in its <i>device_status</i> data member) and returns it to the caller.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_VOID</Strong>
 : none.<Br>&nbsp
<Li><Strong>Argout:<Br>CONST_DEV_STRING</Strong>
 : Status descrition<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="DevStartAll"><!-- --></A>
<A NAME="DevStartAll"><!-- --></A>
<h2>4 - DevStartAll</h2>
<ul>
<Li><Strong>Description: </Strong> Start all device servers controled on the host for the argin level.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_SHORT</Strong>
 : Startup level.<Br>&nbsp
<Li><Strong>Argout:<Br>DEV_VOID</Strong>
 : <Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="DevStopAll"><!-- --></A>
<A NAME="DevStopAll"><!-- --></A>
<h2>5 - DevStopAll</h2>
<ul>
<Li><Strong>Description: </Strong> Stop all device servers controled on the host for the argin level.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_SHORT</Strong>
 : Startup Level.<Br>&nbsp
<Li><Strong>Argout:<Br>DEV_VOID</Strong>
 : <Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="DevGetRunningServers"><!-- --></A>
<A NAME="DevGetRunningServers"><!-- --></A>
<h2>6 - DevGetRunningServers</h2>
<ul>
<Li><Strong>Description: </Strong> Control the running process from property list.
And return the list of the processes which are really running.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_BOOLEAN</Strong>
 : True for all servers. False for controled servers only.<Br>&nbsp
<Li><Strong>Argout:<Br>DEVVAR_STRINGARRAY</Strong>
 : List of the processes which are running.<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="DevGetStopServers"><!-- --></A>
<A NAME="DevGetStopServers"><!-- --></A>
<h2>7 - DevGetStopServers</h2>
<ul>
<Li><Strong>Description: </Strong> Control the running process from property list.
And return the list of the processes which are not running.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_BOOLEAN</Strong>
 : True for all servers. False for controled servers only.<Br>&nbsp
<Li><Strong>Argout:<Br>DEVVAR_STRINGARRAY</Strong>
 : List of the processes which are not running.<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="DevStart"><!-- --></A>
<A NAME="DevStart"><!-- --></A>
<h2>8 - DevStart</h2>
<ul>
<Li><Strong>Description: </Strong> Start the specified server.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_STRING</Strong>
 : Server to be started.<Br>&nbsp
<Li><Strong>Argout:<Br>DEV_VOID</Strong>
 : <Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="DevStop"><!-- --></A>
<A NAME="DevStop"><!-- --></A>
<h2>9 - DevStop</h2>
<ul>
<Li><Strong>Description: </Strong> Stop the specified server.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_STRING</Strong>
 : Servero be stopped.<Br>&nbsp
<Li><Strong>Argout:<Br>DEV_VOID</Strong>
 : <Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="DevReadLog"><!-- --></A>
<A NAME="DevReadLog"><!-- --></A>
<h2>10 - DevReadLog</h2>
<ul>
<Li><Strong>Description: </Strong> At server startup, its standard error is redirected to a log file.
This command will read this file and return the read string from the file.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_STRING</Strong>
 : server name and domain<Br>&nbsp
<Li><Strong>Argout:<Br>CONST_DEV_STRING</Strong>
 : ig Starter/corvus)<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="UpdateServersInfo"><!-- --></A>
<A NAME="UpdateServersInfo"><!-- --></A>
<h2>11 - UpdateServersInfo</h2>
<ul>
<Li><Strong>Description: </Strong> Indicate to the device server than the information about servers to be controlled has been modified.
The device server must read the database to update the servers info list.
If the default case, this command is sent by Database server itself.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_VOID</Strong>
 : <Br>&nbsp
<Li><Strong>Argout:<Br>DEV_VOID</Strong>
 : <Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="StartPollingThread"><!-- --></A>
<A NAME="StartPollingThread"><!-- --></A>
<h2>12 - StartPollingThread</h2>
<ul>
<Li><Strong>Description: </Strong> Start the polling thread for DevState command.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_VOID</Strong>
 : <Br>&nbsp
<Li><Strong>Argout:<Br>DEV_VOID</Strong>
 : <Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>
<A NAME="NotifyDaemonState"><!-- --></A>
<A NAME="NotifyDaemonState"><!-- --></A>
<h2>13 - NotifyDaemonState</h2>
<ul>
<Li><Strong>Description: </Strong> Returns the Notify Daemon state.<Br>&nbsp
<Li><Strong>Argin:<Br>DEV_VOID</Strong>
 : <Br>&nbsp
<Li><Strong>Argout:<Br>DEV_STATE</Strong>
 : Tango::ON if Notify daemon is running else Tango::FAULT.<Br>&nbsp
<Li><Strong>Command allowed for: </Strong><Ul>
<Li>Tango::UNKNOWN<Li>Tango::ON<Li>Tango::ALARM</Ul>
<Br>&nbsp
</ul><Br>
<Br>

<Center>
<Br>
<HR WIDTH="100%"></H5>
<H3> ESRF - Software Engineering Group </H3>
</Center>
</body>
</html>
